//==============================================================================================================================================
// ОБРАБОТЧИК СОБЫТИЯ ПОЛУЧЕНИЯ ДАННЫХ ВЫБОРА
//==============================================================================================================================================

//==============================================================================================================================================
// СЕРВЕРНЫЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

Функция ПолучитьПрогноз(пДатаНачалаПрогноза, пДатаОкончанияПрогноза) Экспорт
	
	ТаблицаДат = Новый ТаблицаЗначений;
	ТаблицаДат.Колонки.Добавить("Дата", Новый ОписаниеТипов("Дата"));
	
	ДатаНачала = НачалоДня(пДатаНачалаПрогноза);
	ДатаОкончания = НачалоДня(пДатаОкончанияПрогноза);
	Пока ДатаНачала <= ДатаОкончания Цикл
		
		СтрокаТЗ = ТаблицаДат.Добавить();
		СтрокаТЗ.Дата = ДатаНачала;
		
		ДатаНачала = КонецДня(ДатаНачала) + 1;
		
	КонецЦикла;
	
	Запрос = Новый Запрос();
	
	Запрос.УстановитьПараметр("ТаблицаДат", 	ТаблицаДат);
	Запрос.УстановитьПараметр("ДатаОкончания", 	КонецДня(пДатаОкончанияПрогноза));
	
	Запрос.Текст = "
		|ВЫБРАТЬ
		|	ТаблицаДат.Дата
		|ПОМЕСТИТЬ
		|	ТаблицаДат
		|ИЗ
		|	&ТаблицаДат КАК ТаблицаДат
		|
		|;
		|
		|ВЫБРАТЬ
		|	ПланируемыеДвижения.ДенежноеХранилище,
		|	ПланируемыеДвижения.Вид,
		|	ТаблицаДат.Дата,
		|	ПланируемыеДвижения.Сумма,
		|	ВЫБОР
		|		КОГДА ПланируемыеДвижения.Периодичность = ЗНАЧЕНИЕ(Перечисление.Периодичность.День)
		|			ТОГДА ИСТИНА
		|		КОГДА ПланируемыеДвижения.Периодичность = ЗНАЧЕНИЕ(Перечисление.Периодичность.Месяц)
		|				И ПланируемыеДвижения.Дата = ДАТАВРЕМЯ(1, 1, 1)
		|				И КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ДЕНЬ) = КОНЕЦПЕРИОДА(ТаблицаДат.Дата, МЕСЯЦ)
		|			ТОГДА ИСТИНА
		|		КОГДА ПланируемыеДвижения.Периодичность = ЗНАЧЕНИЕ(Перечисление.Периодичность.Месяц)
		|				И ПланируемыеДвижения.Дата <> ДАТАВРЕМЯ(1, 1, 1)
		|				И (ДЕНЬ(ТаблицаДат.Дата) = ДЕНЬ(ПланируемыеДвижения.Дата)
		|					ИЛИ ДЕНЬ(ПланируемыеДвижения.Дата) > ДЕНЬ(КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ДЕНЬ))
		|						И КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ДЕНЬ) = КОНЕЦПЕРИОДА(ТаблицаДат.Дата, МЕСЯЦ))
		|			ТОГДА ИСТИНА
		|		КОГДА ПланируемыеДвижения.Периодичность = ЗНАЧЕНИЕ(Перечисление.Периодичность.Квартал)
		|				И ПланируемыеДвижения.Дата = ДАТАВРЕМЯ(1, 1, 1)
		|				И КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ДЕНЬ) = КОНЕЦПЕРИОДА(ТаблицаДат.Дата, КВАРТАЛ)
		|			ТОГДА ИСТИНА
		|		КОГДА ПланируемыеДвижения.Периодичность = ЗНАЧЕНИЕ(Перечисление.Периодичность.Год)
		|				И ПланируемыеДвижения.Дата = ДАТАВРЕМЯ(1, 1, 1)
		|				И КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ДЕНЬ) = КОНЕЦПЕРИОДА(ТаблицаДат.Дата, ГОД)
		|			ТОГДА ИСТИНА
		|		ИНАЧЕ ЛОЖЬ
		|	КОНЕЦ КАК ПодходитПодПериод
		|ПОМЕСТИТЬ
		|	ТаблицаДвижений
		|ИЗ
		|	РегистрСведений.ПланируемыеДвижения.СрезПоследних(&ДатаОкончания) КАК ПланируемыеДвижения
		|	ВНУТРЕННЕЕ СОЕДИНЕНИЕ
		|		ТаблицаДат КАК ТаблицаДат
		|	ПО
		|		ИСТИНА
		|ГДЕ
		|	ПланируемыеДвижения.ПризнакАктивности = ИСТИНА
		|
		|;
		|	
		|ВЫБРАТЬ
		|	ТаблицаДвижений.ДенежноеХранилище	КАК ДенежноеХранилище,
		|	ТаблицаДвижений.Дата 				КАК Дата,
		|	ТаблицаДвижений.Вид					КАК Вид,
		|	ТаблицаДвижений.Сумма				КАК Сумма,
		|	ТаблицаДвижений.Вид.Наименование 	КАК Комментарий
		|ИЗ
		|	ТаблицаДвижений КАК ТаблицаДвижений
		|ГДЕ
		|	ТаблицаДвижений.ПодходитПодПериод = ИСТИНА
		|УПОРЯДОЧИТЬ ПО
		|	ТаблицаДвижений.Вид.Наименование,
		|	ТаблицаДвижений.Дата
		|";

	Возврат Запрос.Выполнить().Выгрузить();

КонецФункции // ПолучитьПрогноз()
